/* (c) David Alan Gilbert 1995 */
/* This produces an assembler source file (on stdout) with constants
   for use by the loader.

   KERNELPATH should be defined on the gcc command line
*/
#include <stdio.h>

long FileLen(FILE *handle) {
  long oldpos,len;

  oldpos=ftell(handle);
  fseek(handle,0,SEEK_END);
  len=ftell(handle);
  fseek(handle,oldpos,SEEK_SET);

  return len;
};


int main() {
  FILE *hfKernel=fopen(KERNELPATH,"rb");
  long KernelFileLen;

  if (hfKernel==NULL) {
    fprintf(stderr,"Couldn't open kernel image\n");
    exit(1);
  };

  KernelFileLen=FileLen(hfKernel);

  if (KernelFileLen<1024) {
    fprintf(stderr,"Damn small kernel!\n");
    exit(1);
  };

  printf("@ Automatically generated by imgfiddle.c\n");
  printf("  .text\n  .align\n  .global kernlen\nkernlen:\n  .word 0x%08x\n",KernelFileLen);
  fclose(stdout);

  fclose(hfKernel);
}
