/* (c) David Alan Gilbert 1995 */
/* with parts from linux/arch/arm/kernel/setup.c Copyright (C) 1995  Russell King */
/* Create a config file */

#include <stdio.h>

struct param_struct
{
  union {
    struct {
      unsigned int page_size;  
      unsigned int nr_pages;
      unsigned int ramdisk_size; /**/
      unsigned int flags;
      unsigned int rootdev;    /**/
      unsigned int video_num_cols; /**/
      unsigned int video_num_rows; /**/
      unsigned int video_x;    /**/ 
      unsigned int video_y;    /**/
      unsigned int memc_control_reg; /**/
      unsigned char sounddefault;
      unsigned char adfsdrives;
      unsigned char bytes_per_char_h; /**/
      unsigned char bytes_per_char_v; /**/
      unsigned int pages_in_bank[4];
      unsigned int pages_in_vram;
      unsigned int initrd_start;
      unsigned int initrd_size;
      unsigned int rd_start;
    } s;
    char unused[256];
  } u1;
  union {
    char paths[8][128];   /**/
    struct {
      unsigned int magic;
      char n[1024 - sizeof(unsigned int)];
    } s;
  } u2;
  char commandline[256];    /**/
};

struct param_struct params;

int main() {
  params.u1.s.page_size=32*1024;
  params.u1.s.nr_pages=128;
  params.u1.s.ramdisk_size=0;
  params.u1.s.flags=0;
  params.u1.s.rootdev=0x0200; /* Thats first device on floppy */
  params.u1.s.rootdev=0x1500; /* mfma */
  params.u1.s.video_num_cols=80;
  params.u1.s.video_num_rows=64;
  params.u1.s.video_x=0;
  params.u1.s.video_y=0;
  params.u1.s.memc_control_reg=0x036e170c;
  params.u1.s.sounddefault=0;
  params.u1.s.adfsdrives=0x14; /* 0x14 for 4 floopies, 2 MFM   ... 0xc for 2 floppies, 1 MFM? */
  params.u1.s.bytes_per_char_h=4;
  params.u1.s.bytes_per_char_v=8;
  params.u1.s.pages_in_bank[0]=0;
  params.u1.s.pages_in_bank[1]=0;
  params.u1.s.pages_in_bank[2]=0;
  params.u1.s.pages_in_bank[3]=0;
  params.u1.s.pages_in_vram=0;
  params.u1.s.initrd_start=0;
  params.u1.s.initrd_size=0;
  params.u1.s.rd_start=0;
  strcpy(params.u2.paths[0],"partitions.linux.mfma1");
  strcpy(params.u2.paths[1],"partitions.linux.mfma2");
  strcpy(params.u2.paths[2],"partitions.linux.mfma3");
  strcpy(params.u2.paths[3],"partitions.linux.mfma4");
  strcpy(params.u2.paths[4],"partitions.linux.mfmb1");
  strcpy(params.u2.paths[5],"partitions.linux.mfmb2");
  strcpy(params.u2.paths[6],"partitions.linux.mfmb3");
  strcpy(params.u2.paths[7],"partitions.linux.mfmb4");
  strcpy(params.commandline,"montype=multi initswap=/swapfile");

  fwrite(&params,sizeof(params),1,stdout);

  return 0;
};
